package com.notificationFramework.notification;

import android.annotation.TargetApi;
import android.app.NotificationChannel;
import android.support.v4.app.NotificationCompat;

import com.notificationFramework.sedentary.frontEnd.R;

/**
 * Created by Peter De Jonckheere on 09/03/2018.
 */

public class GoalNotification extends SedentaryNotification {


    protected NotificationCompat.Builder setParameters(NotificationCompat.Builder builder) {
        builder = super.setParameters(builder);
        builder.setContentTitle(this.getClass().getSimpleName());
        builder.setContentText(preferences.getString(getString(R.string.daily_goal_text), getString(R.string.default_notification_message)));
        if(preferences.getBoolean(getString(R.string.vibration), false)) {
            builder.setVibrate(new long[]{0, 500, 0, 500});
        }
        return builder;
    }


    @TargetApi(26)
    protected NotificationChannel setChannelParameters(NotificationChannel nc) {
        nc = super.setChannelParameters(nc);
        nc.setDescription(this.getClass().getName());
        return nc;
    }
}
